;===============================================================================
; issup.ahk
;	http://39kasen.sakura.ne.jp/iss/
; IllustStudioŃc[Vtggpł悤ɂXNvgłB
;
; 2009/05/10
;
;  issup.ahkPDS(pubNhC\tgEFA)łB
;  ρEĔzzȂǎRɍsĉB
;  
;  XNvg̎gpɂ萶Ȃ鑹Qɑ΂Ă
;  ҂͈؂̐ӔC𕉂܂B
;===============================================================================
#NoEnv
#EscapeChar \
SetWorkingDir %A_ScriptDir%
CoordMode, Pixel, Screen
CoordMode, Mouse, Screen
CoordMode, ToolTip, Screen

ISS_hLib_imgctl := DllCall("LoadLibrary", Str, "imgctl.dll", UInt)

OnExit, ISS_Quit

ISS_INI := A_ScriptDir "\\issup.ini"
ISS_DIBFolder := A_ScriptDir "\\dib"

ISS_Init()
ISS_InitToolList()

Gosub, ISS_InitGUI

WinActivate, %ISS_ISMainWindow%

return	;auto-executeZNVI

#include *i issup_user.ahk

;===============================================================================
;                                XNvg
;===============================================================================
;XNvgTXyh
ISS_Suspend:
	Suspend
	If (A_IsSuspended)
		Warn("TXyh")
	else
		Warn("TXyh", 1000)
	Menu, ISSMenu, % A_IsSuspended ? "Check" : "Uncheck", TXyh
	return

;XNvg[h
ISS_Reload:
	If (ISS_MwSavePos)
		ISS_SaveWindowPos()
	Reload

;XNvgI
GuiClose:
ISS_Quit:
	DllCall("FreeLibrary", UInt, ISS_hLib_imgctl)
	If (ISS_MwSavePos)
		ISS_SaveWindowPos()
	ExitApp

;===============================================================================
;                                    
;===============================================================================
ISS_Init()
{
	Local ini 
	IniRead, ISS_ISMainWindow, %ISS_INI%
				, Settings, IllustStudioWindow, ahk_class IS10FrameWnd
	IfWinExist, %ISS_ISMainWindow%
	{
		WinGet, ISS_ISHwnd, ID, %ISS_ISMainWindow%
		WinGet, ISS_ISPID, PID, %ISS_ISMainWindow%
		GroupAdd, ISWindow, ahk_pid %ISS_ISPID%
	}
	else {
		GroupAdd, ISWindow, %ISS_ISMainWindow%
		GroupAdd, ISWindow, ahk_class CRibToolPalette
		GroupAdd, ISWindow, ahk_class CRibToolPreviewPalette
		GroupAdd, ISWindow, ahk_class CRibToolOptionPalette
		GroupAdd, ISWindow, ahk_class CRibToolStylePalette
		GroupAdd, ISWindow, ahk_class CRibToolSetPalette
		GroupAdd, ISWindow, ahk_class CRibLayerPalette
		GroupAdd, ISWindow, ahk_class CRibLayerPropertyPalette
		GroupAdd, ISWindow, ahk_class CRibColorPalette
		GroupAdd, ISWindow, ahk_class CRibColorSetPalette
		GroupAdd, ISWindow, ahk_class CRibColorGuidePalette
		GroupAdd, ISWindow, ahk_class CRibColorBlendPalette
		GroupAdd, ISWindow, ahk_class CRibNavigatorPalette
		GroupAdd, ISWindow, ahk_class CRibSubPalette
		GroupAdd, ISWindow, ahk_class CMaterialPalette
		GroupAdd, ISWindow, ahk_class CRibHistoryPalette
		GroupAdd, ISWindow, ahk_class CRibActionPalette
	}
	
	IniRead, ini, %ISS_INI%, Settings, FirstBoot, 1
	If (ini)
		ISS_FirstBoot()
	
	IniRead, ISS_ToolShiftWait, %ISS_INI%, Settings, ToolShiftWait, 500
	
	IniRead, ISS_CurrentToolX, %ISS_INI%, CurrentTool, X, 337
	IniRead, ISS_CurrentToolY, %ISS_INI%, CurrentTool, Y, 4
	IniRead, ISS_CurrentToolW, %ISS_INI%, CurrentTool, Width, 96
	IniRead, ISS_CurrentToolH, %ISS_INI%, CurrentTool, Height, 14
	return
}

;===============================================================================
;                                N
;===============================================================================
ISS_FirstBoot()
{
	Global ISS_INI
	If (ISS_GetToolKeys()) {
		MsgBox, c[EV[gJbg擾łȂ\nc[Vtg͎gpł܂B
		ExitApp
	}
	ISS_InitToolList()
	If (ISS_GetCurrentToolPos()) {
		MsgBox, [Jgc[]\\ʒu擾łȂ\nc[Vtg͎gpł܂B
		ExitApp
	}
	If (ISS_MakeToolDIB()) {
		MsgBox, c[ʗpDIB擾łȂ\nc[Vtg͎gpł܂B
		ExitApp
	}
	MsgBox, ŏݒ肪܂B\nc[Vtggpł邩ǂmFĂB
	IniWrite, 0, %ISS_INI%, Settings, FirstBoot
	Reload
}

;c[EV[gJbgL[擾
ISS_GetToolKeys()
{
	Global ISS_INI, ISS_ISPID
	Loop {
		MsgBox, 4097, c[EV[gJbg擾
			, % "c[ƃV[gJbg擾܂B\n\n"
			. "IllustStudio[t@C]j[\n"
			. "[JX^}CY] > [V[gJbgݒ...]J\n"
			. "uc[v^uIÃEBhE[OK]{^ĉB"
		IfMsgBox, Cancel
			return 1
		IfWinExist, V[gJbgݒ ahk_pid %ISS_ISPID%
			break
	}
	Loop {
		toollist := ""
		WinActivate, V[gJbgݒ ahk_pid %ISS_ISPID%
		ControlGet, tlist, List,, ListBox1, V[gJbgݒ
		Control, Choose, 1, ListBox1, V[gJbgݒ
		ControlFocus, ListBox1, V[gJbgݒ
		Loop, PARSE, tlist, \n
		{
			ControlGet, tool, Choice,, ListBox1, V[gJbgݒ
			Sleep, 50
			ControlGetText, key, Edit1, V[gJbgݒ
			StringLower, key, key
			Send, {Down}
			If (key != "" && !RegExMatch(tool, "^-+$"))
				toollist .= key "\t" tool "\n"
		}
		StringTrimRight, toollist, toollist, 1
		MsgBox, 3, c[EL[ꗗ
			, % "L[\tc[\n----------------------------------------\n"
			. toollist "\n\n"
			. "LŖȂ[͂]ĉB\n"
			. "[]Ƃx擾݂܂B"
		IfMsgBox, No
			Continue
		IfMsgBox, Cancel
			return 1
		break
	}
	toolcnt := 0
	colorcnt := 0
	color_name := "CJ[|TuJ[|"
	Loop, PARSE, toollist, \n
	{
		StringSplit, var, A_LoopField, %A_Tab%
		IfNotInString, color_name, %var2%
		{
			toolcnt ++
			IniWrite, %var2%%A_Tab%%var1%, %ISS_INI%, Tools, Tool%toolcnt%
		}
		else {
			colorcnt ++
			IniWrite, %var2%%A_Tab%%var1%, %ISS_INI%, Colors, Color%colorcnt%
		}
	}
	IniWrite, %toolcnt%, %ISS_INI%, Tools, Count
	IniWrite, %colorcnt%, %ISS_INI%, Colors, Count
	Sleep, 200
	WinClose, V[gJbgݒ ahk_pid %ISS_ISPID%
	
	return 0
}

;[Jgc[]\ʒu擾
ISS_GetCurrentToolPos()
{
	Global ISS_CurrentToolX, ISS_CurrentToolY
	Global ISS_CurrentToolW, ISS_CurrentToolH
	gui_num := ISS_GetNewGui()
	Loop{
		ControlGet, hwnd, Hwnd,, CMainPalettebar1, ahk_class IS10FrameWnd
		WinGetPos, wx, wy, ww, wh, ahk_id %hwnd%
		
		hdc := DllCall("GetWindowDC", UInt, hwnd, UInt)
		
		Gosub, ISS_GetCurrentToolPosDialog1
		hdib1 := DllCall("imgctl\\DCtoDIB", UInt, hdc, Int, 0, Int, 0, Int, ww, Int, wh, UInt)
		Gosub, ISS_GetCurrentToolPosDialog2
		hdib2 := DllCall("imgctl\\DCtoDIB", UInt, hdc, Int, 0, Int, 0, Int, ww, Int, wh, UInt)
		
		DllCall("imgctl\\MapDIB", UInt, hdib1, UInt, 0, UInt, 0, UIntP, pdib1, UIntP, dib_size1)
		DllCall("imgctl\\MapDIB", UInt, hdib2, UInt, 0, UInt, 0, UIntP, pdib2, UIntP, dib_size2)
		ProcessBuffer_XOR(pdib1, dib_size1, pdib2, dib_size2)
		DllCall("imgctl\\DeleteDIB", UInt, hdib2)
		DllCall("ReleaseDC", UInt, hwnd, UInt, hdc)

		;Wo
		Loop, %wh% {
			y := A_Index - 1
			Loop, %ww% {
				x := A_Index - 1
				col := DllCall("imgctl\\PixelDIB", UInt, hdib1, UInt, x, UInt, y)
				If (col)
					break
			}
			If (col)
				break
		}
		If (x >= ww - 1 && y >= wh - 1) {
			DllCall("imgctl\\DeleteDIB", UInt, hdib1)
			MsgBox, 5, mF
				, % "oł܂łB\n\n"
				. "x蒼ꍇuĎsvĉB\n"
				. "uLZvƃXNvgI܂B"
			IfMsgBox, Cancel
				return 1
			Continue
		}
		;o
		Loop, % ww - x {
			x2 := x + A_Index
			If (!DllCall("imgctl\\PixelDIB", UInt, hdib1, UInt, x2, UInt, y))
				break
		}
		;o
		Loop, % wh - y {
			y2 := y + A_Index
			If (!DllCall("imgctl\\PixelDIB", UInt, hdib1, UInt, x, UInt, y2))
				break
		}
		DllCall("imgctl\\DeleteDIB", UInt, hdib1)
		
		ISS_CurrentToolX := x + 2
		ISS_CurrentToolY := y + 2
		ISS_CurrentToolW := x2 - x - 4
		ISS_CurrentToolH := y2 - y - 4
		;mFpԘg\
		x := ISS_CurrentToolX + wx - 4
		y := ISS_CurrentToolY + wy - 4
		Gui, %gui_num%:Color, Red
		Gui, %gui_num%:Margin, 4, 4
		Gui, %gui_num%:Add, Picture, w%ISS_CurrentToolW% h%ISS_CurrentToolH% +0x06
		Gui, %gui_num%:+LastFound
		WinSet, TransColor, White
		Gui, %gui_num%:-Caption -Border +AlwaysOnTop +ToolWindow
		Gui, %gui_num%:Show, x%x% y%y%
		
		MsgBox, 4132, mF, uJgc[v\\ӏɐԘg\\Ă܂H
		Gui, %gui_num%:Destroy
		IfMsgBox, YES
			Break
	}
	IniWrite, %ISS_CurrentToolX%, issup.ini, CurrentTool, X
	IniWrite, %ISS_CurrentToolY%, issup.ini, CurrentTool, Y
	IniWrite, %ISS_CurrentToolW%, issup.ini, CurrentTool, Width
	IniWrite, %ISS_CurrentToolH%, issup.ini, CurrentTool, Height
	return

ISS_GetCurrentToolPosDialog1:
	gui_num2 := ISS_GetNewGui()
	Gui, %gui_num2%:Add, Text, ym+10, uJgc[v\\ʒu擾܂B
	Gui, %gui_num2%:Add, Text,, % "@c[Vtggpɂ́A\n"
		. "c[o[ɁuJgc[v\\ĂKv܂B"
	Gui, %gui_num2%:Add, Picture,, _img1.png
	Gui, %gui_num2%:Add, Text,, % "@\\ĂȂꍇA\n"
		. "[t@C]j[[JX^}CY] > [c[o[̃JX^...]J\n"
		. "uJgc[vɃ`FbNtĂB\n"
	Gui, %gui_num2%:Add, Text,, % "@uJgc[ṽEBhEȂǂĉBĂȂƂmF\n"
		. "[OK] ĉB"
	Gui, %gui_num2%:Add, Button, xm+120 w80 gISS_GetCurrentToolPosBtn, OK
	Gui, %gui_num2%:+AlwaysOnTop
	Gui, %gui_num2%:Show,, Jgc[\\ʒu擾
	btn_pressed := false
	While (!btn_pressed)
		Sleep, 100
	Gui, %gui_num2%:Destroy
	return

ISS_GetCurrentToolPosBtn:
	btn_pressed := true
	return

ISS_GetCurrentToolPosDialog2:
	gui_num2 := ISS_GetNewGui()
	Gui, %gui_num2%:Add, Picture,, _img2.png
	Gui, %gui_num2%:Add, Text,, % "@uJgc[v[Ctrl]L[ȂuENbNvĉB"
	Gui, %gui_num2%:+AlwaysOnTop
	Gui, %gui_num2%:Show,, Jgc[\\ʒu擾
	Loop {
		KeyWait, RButton, D
		If (GetKeyState("Ctrl"))
			break
		KeyWait, RButton
	}
	Gui, %gui_num2%:Destroy
	return
}

;obt@1obt@2ƂXORŏ㏑
ProcessBuffer_XOR(ptr1, size1, ptr2, size2)
{
	size := size1 < size2 ? size1 : size2
	offset := 0
	Loop, % size // 4 {	;̂4oCg
		NumPut(NumGet(ptr1+0, offset, "UInt") ^ NumGet(ptr2+0, offset, "UInt"), ptr1+0, offset, "UInt")
		offset += 4
	}
	Loop, % Mod(size, 4) {	;c
		NumPut(NumGet(ptr1+0, offset, "UChar") ^ NumGet(ptr2+0, offset, "UChar"), ptr1+0, offset, "UChar")
		offset ++
	}
	return
}

;c[ʗpDIB擾
ISS_MakeToolDIB()
{
	Local hdc, hdib, bmi, dib, ret
	If (!ISS_CurrentToolX)
		return 1
	If (!InStr(FileExist(ISS_DIBFolder), "D"))
		FileCreateDir, %ISS_DIBFolder%	;DIBۑptH_쐬
	MsgBox, 4096, c[ʗpDIB擾
		, % "c[ʗprbg}bv擾܂B\n"
		. "c[o[́uJgc[ṽEBhEȂǂ\n"
		. "BĂȂƂmF[OK]ĉB"
	WinActivate, %ISS_ISMainWindow%
	ControlGet, hwnd, Hwnd,, CMainPalettebar1, ahk_class IS10FrameWnd
	If (VarSetCapacity(bmi, ISS_CurrentToolBMISize) < ISS_CurrentToolBMISize) {
		MsgBox, % "G[: BMIobt@̊mۂɎs܂B\n"
				. "c[ʗpDIB̎擾͂ł܂B"
		return 1
	}
	Progress, B2 R1-%ToolCnt% FM11 FS11, I܂ő삵ȂŉB, c[ʗprbg}bv擾
	hdc := DllCall("GetWindowDC", UInt, hwnd, UInt)
	Sleep, 200
	Send, % Tool%ToolCnt%_Key	;UŌ̃c[ɐ؂ւ
	Sleep, 330
	Loop, %ToolCnt% {
		Progress, %A_Index%
		Send, % Tool%A_Index%_Key
		Sleep, 330
		hdib := DllCall("imgctl\\DCtoDIB", UInt, hdc
			, Int, ISS_CurrentToolX, Int, ISS_CurrentToolY
			, Int, ISS_CurrentToolW, Int, ISS_CurrentToolH, UInt)
		If (VarSetCapacity(Tool%A_Index%_DIB, ISS_CurrentToolDIBSize, 0) < ISS_CurrentToolDIBSize) {
			MsgBox, % "Tool" A_Index "_DIB̊mۂɎs܂B\n"
					. "c[ʗpDIB̎擾͂ł܂B"
			DllCall("imgctl\\DeleteDIB", UInt, hdib)
			DllCall("ReleaseDC", UInt, hwnd, UInt, hdc)
			return 1
		}
		DllCall("imgctl\\GetDIB", UInt, hdib
				, Str, bmi, UIntP, ISS_CurrentToolBMISize
				, Str, Tool%A_Index%_DIB, UIntP, ISS_CurrentToolDIBSize)
		DllCall("imgctl\\DeleteDIB", UInt, hdib)
		FileDelete, % ISS_DIBFolder "\\_dib_" Tool%A_Index%_Name
		FileAppend, % Tool%A_Index%_DIB
				, % "*" ISS_DIBFolder "\\_dib_" Tool%A_Index%_Name
	}
	DllCall("ReleaseDC", UInt, hwnd, UInt, hdc)
	Progress, Off
	return
}

;===============================================================================
;                         Wc[^c[Vtg֘A
;===============================================================================
;c[VtgpXg쐬
ISS_InitToolList()
{
	Local cnt, ini, keyasc
	ToolCnt := 0
	IniRead, cnt, %ISS_INI%, Tools, Count, 0
	Hotkey, IfWinActive, ahk_group ISWindow
	loop, %cnt% {
		IniRead, ini, %ISS_INI%, Tools, Tool%A_Index%, 0
		If (!ini)
			continue
		ToolCnt++
		ISS_SplitVar(ini, A_Tab, false, Tool%ToolCnt%_Name, Tool%ToolCnt%_Key)
		keyasc := Asc(Tool%ToolCnt%_Key)
		ToolKey%keyasc%_Cnt++
		Tool%ToolCnt%_Order  := ToolKey%keyasc%_Cnt
		FileRead, Tool%ToolCnt%_DIB, % ISS_DIBFolder "\\_dib_" Tool%ToolCnt%_Name
		HotKey, % Tool%ToolCnt%_Key, ISS_ProcToolKey
	}
	If (ISS_InitCurrentToolBufferSize()) {
		ExitApp
	}
	return
}

;c[Vtg L[
ISS_ProcToolKey:
	If (ISS_IsEditActive())
		Send, %A_ThisHotKey%
	else {
	;	ISS_ImeOff()
		ISS_ProcToolKey(A_ThisHotKey)
	}
	return

ISS_ProcToolKey(key)
{
	Global ISS_LastToolKey, ISS_ToolShiftWait
	Static last_tool
	If (A_TimeSincePriorHotkey < 0 || A_TimeSincePriorHotkey > 500)
		last_tool := ISS_GetCurrentTool()
	;L[
	Send, %key%
	;c[Vtgҋ@
	KeyWait, %key%, % "T" (ISS_ToolShiftWait / 1000)
	If (!ErrorLevel) {
		ISS_LastToolKey := key
		return
	}
	If (last_tool)
		mes("c[VtgL")
	else {
		mes("c[Vtgs: c[擾ł܂ł")
		ISS_LastToolKey := key
	}
	KeyWait, %key%
	mes()
	If (last_tool)
		ISS_ChangeTool(last_tool)
	return
}

;c[ύX
ISS_ChangeTool(tool)
{
	Local current, key, cnt
	if tool is not Integer
		tool := ISS_GetToolNumber(tool)
	If (!tool)
		return 1
	if ((current := ISS_GetCurrentTool()) == tool)
		return 0
	key := Tool%tool%_Key
	cnt := Tool%tool%_Order
	If (Tool%current%_Key == key) {
		if (Tool%current%_Order > cnt)
			cnt += ISS_GetToolKeyCnt(key)
		cnt -= Tool%current%_Order
	}
	Send, {%key% %cnt%}
	ISS_LastChangedTool := tool
	return 0
}

ISS_InitCurrentToolBufferSize()
{
	Local hdc, hdib
	hdc:=DllCall("GetWindowDC", UInt, hwnd, UInt)
	hdib:=DllCall("imgctl\\DCtoDIB", UInt, hdc
		, Int, ISS_CurrentToolX, Int, ISS_CurrentToolY
		, Int, ISS_CurrentToolW, Int, ISS_CurrentToolH, UInt)
	ISS_CurrentToolBMISize := 0
	ISS_CurrentToolDIBSize := 0
	DllCall("imgctl\\GetDIB", UInt, hdib
		, UInt, 0, UIntP, ISS_CurrentToolBMISize
		, UInt, 0, UIntP, ISS_CurrentToolDIBSize)
	DllCall("imgctl\\DeleteDIB", UInt, hdib)
	DllCall("ReleaseDC", UInt, hwnd, UInt, hdc)
}

;Jgc[擾
ISS_GetCurrentTool()
{
	Local hwnd, hdc, hdib, bmi, dib
	ControlGet, hwnd, Hwnd,, CMainPalettebar1, ahk_class IS10FrameWnd
	
	hdc := DllCall("GetWindowDC", UInt, hwnd, UInt)
	hdib := DllCall("imgctl\\DCtoDIB", UInt, hdc
		, Int, ISS_CurrentToolX, Int, ISS_CurrentToolY
		, Int, ISS_CurrentToolW, Int, ISS_CurrentToolH, UInt)
	;DIB擾pobt@m
	If (VarSetCapacity(bmi, ISS_CurrentToolBMISize) < ISS_CurrentToolBMISize) {
		warn("c[擾G[: BMIobt@mێs")
		return 0
	}
	If (VarSetCapacity(dib, ISS_CurrentToolDIBSize, 0) < ISS_CurrentToolDIBSize) {
		warn("c[擾G[: DIBobt@mێs")
		return 0
	}
	;DIB擾
	DllCall("imgctl\\GetDIB", UInt, hdib
		, Str, bmi, UIntP, ISS_CurrentToolBMISize
		, Str, dib, UIntP, ISS_CurrentToolDIBSize)
	
	DllCall("imgctl\\DeleteDIB", UInt, hdib)
	DllCall("ReleaseDC", UInt, hwnd, UInt, hdc)
	;OXNvgŕύXc[Ɣr
	If (ISS_LastChangedTool) {
		If (CompareBuffer(Tool%ISS_LastChangedTool%_DIB, dib))
			return ISS_LastChangedTool
	}
	;ׂẴc[Ɣr
	Loop, %ToolCnt% {
		If (CompareBuffer(Tool%A_Index%_DIB, dib))
			return A_Index
	}
	return 0
}

;̃obt@r
CompareBuffer(ByRef buf1, ByRef buf2)
{
	If (buf1 != buf2)
		return false
	size1 := VarSetCapacity(buf1)
	size2 := VarSetCapacity(buf2)
	If (StrLen(buf1) == size1)	;buf10x00Ȃbuf1==buf2
		return true
	;0x00APIŔr
	ret := DllCall("CompareString"
		,Int, 0x800		;LCID Locale,       // P[ʎq
		,UInt, 0 		;DWORD dwCmpFlags,  // r@̃IvV
		,Str, buf1		;LPCTSTR lpString1, // ŏ̕
		,Int, size1		;int cchCount1,     // ŏ̃̕TCY
		,Str, buf2		;LPCTSTR lpString2, // 2 Ԗڂ̕
		,Int, size1)	;int cchCount2      // 2 Ԗڂ̃̕TCY
	;CSTR_LESS_THAN	1
	;CSTR_EQUAL	2
	;CSTR_GREATER_THAN 3
	return ret == 2 ? true : false
}

ISS_GetToolNumber(toolname)
{
	Global ToolCnt
	Loop, %ToolCnt%
	{
		if (Tool%A_Index%_Name == toolname)
			return A_Index
	}
	return 0
}

ISS_GetToolKeyCnt(key)
{
	Local keyasc
	keyasc := Asc(key)
	return ToolKey%keyasc%_Cnt
}

;===============================================================================
;                                     GUI֘A
;===============================================================================
ISS_InitGUI:
	ISS_CreateMessageWindow()
	ISS_CreateMenu()
	OnMessage(0x84,"ISS_WM_NCHITTEST")	;hbOŃEBhEړ
	OnMessage(0xA1,"ISS_WM_NCLBUTTONDOWN")	;NbNŌxbZ[WZbg
	OnMessage(0xA3,"ISS_ShowContextMenu")	;WM_NCLBUTTONDBCLK j[\
	OnMessage(0xA4,"ISS_ShowContextMenu")	;WM_NCRBUTTONUP
	OnMessage(0xA0,"ISS_WM_NCMOUSEMOVE")	;WM_NCACTIVATE
	return

;bZ[WEBhE쐬
ISS_CreateMessageWindow()
{
	Global ISS_INI, ISS_MwCtlMes, ISS_MwCtlWarn
	     , ISS_MwSavePos, ISS_MwBGColor, ISS_MwWarnColor
	;ݒǂݍ
	IniRead, mwVisible, %ISS_INI%, MessageWindow, Visible, 1
	IniRead, ISS_MwSavePos, %ISS_INI%, MessageWindow, SavePos, 1
	IniRead, mwX, %ISS_INI%, MessageWindow, X
	IniRead, mwY, %ISS_INI%, MessageWindow, Y
	IniRead, mwMarginX, %ISS_INI%, MessageWindow, MarginX, 4
	IniRead, mwMarginY, %ISS_INI%, MessageWindow, MarginY, 3
	IniRead, mwMW, %ISS_INI%, MessageWindow, MWidth, 280
	IniRead, mwFont, %ISS_INI%, MessageWindow, Font
	IniRead, mwFontSize, %ISS_INI%, MessageWindow, FontSize, 10
	IniRead, ISS_MwBGColor, %ISS_INI%, MessageWindow, BGColor, Black
	IniRead, mwMCol, %ISS_INI%, MessageWindow, MessageColor, Lime
	IniRead, ISS_MwWarnColor, %ISS_INI%, MessageWindow, WarningColor, Red
	;EBhE쐬
	Gui, 1:Color, %ISS_MwBGColor%
	Gui, 1:Margin, %mwMarginX%, %mwMarginY%
	Gui, 1:Font, S%mwFontSize% ,%mwFont%
	Gui, 1:Add, Text, ym w%mwMW% c%mwMCol% vISS_MwCtlMes, issup.ahk	;bZ[W
	Gui, 1:Add, Text, xp w%mwMW% c%ISS_MwWarnColor% Hidden vISS_MwCtlWarn,-	;x
	Gui, 1:Add, Text, X+0 c%mwMCol% gISS_Quit, ~
	Gui, 1:+AlwaysOnTop
	Gui, 1:+ToolWindow -Caption -Border
	If (mwVisible)
		Gui, 1:Show,% mwX && mwY ? "X" mwX " Y" mwY : "", ISS_MessageWindow
	return mwVisible
}

;ReLXgj[쐬
ISS_CreateMenu()
{
	Menu, ISSMenu, Add, c[Vtgݒ, ISS_Menu_ToolShiftSetting
	Menu, ISSMenu, Add
	Menu, ISSMenu, Add, c[EV[gJbgĎ擾, ISS_Menu_GetToolKeys
	Menu, ISSMenu, Add, Jgc[\\ʒuĎ擾, ISS_Menu_GetCurrentToolPos
	Menu, ISSMenu, Add, c[ʗprbg}bvĎ擾, ISS_Menu_MakeToolDIB
	Menu, ISSMenu, Add
	Menu, ISSMenu, Add, TXyh, ISS_Suspend
	Menu, ISSMenu, Add, XNvgċN, ISS_Reload
	Menu, ISSMenu, Add, I, ISS_Quit
	
	return
}

;j[ITu[`
ISS_Menu_GetToolKeys:
ISS_Menu_GetCurrentToolPos:
ISS_Menu_MakeToolDIB:
	funcname := RegExReplace(A_ThisLabel, "ISS_Menu", "ISS")
	%funcname%()
	Gosub, ISS_Reload
	return

ISS_Menu_ToolShiftSetting:
	ISS_ToolShiftSetting()
	WinActivate, %ISS_ISMainWindow%
	return

ISS_ToolShiftSetting()
{
	Global ISS_ToolShiftWait, ISS_INI
	InputBox, var, c[Vtgݒ, c[VtgLɂȂ܂ł̎(~b)
		,, 320, 120,,,,, %ISS_ToolShiftWait%
	If (ErrorLevel == 0) {
		If var is Integer
		{
			ISS_ToolShiftWait := var
			IniWrite, %var%, %ISS_INI%, Settings, ToolShiftWait
			mes(var "~bɐݒ肵܂B", 2000)
		}
		else
			warn("ȊO̒l͂܂B", 3000)
	}
}

;bZ[WEBhEʒuۑ
ISS_SaveWindowPos()
{
	Global ISS_INI, ISS_MwSavePos
	If (!ISS_MwSavePos)
		return
	WinGetPos, x, y,,, ISS_MessageWindow
	IniWrite, %x%, %ISS_INI%, MessageWindow, X
	IniWrite, %y%, %ISS_INI%, MessageWindow, Y
	return
}

;===============================================================================
;                           EBhEbZ[W
;===============================================================================
;hbOŃEBhEړ
ISS_WM_NCHITTEST()
{
	If (A_Gui != 1)
		return
	return 2
}

;NbNŌxbZ[WZbg
ISS_WM_NCLBUTTONDOWN()
{
	If (A_Gui != 1)
		return
	OnMessage(0xA0,"")	;WM_NCMOUSEMOVE
	Gosub ISS_warnReset
	SetTimer, ISS_NCLButtonCheck, 100
	return
}

;{^JANeBuEBhEɂǂ
ISS_NCLButtonCheck:
	If (!GetKeyState("LButton")) {
		SetTimer, ISS_NCLButtonCheck, Off
		If (ISS_hActiveWnd)
			WinActivate, ahk_id %ISS_hActiveWnd%
		OnMessage(0xA0, "ISS_WM_NCMOUSEMOVE")
	}
	return

;bZ[WEBhE_uNbN^ENbNŃj[\
;WM_NCLBUTTONDBCLK / WM_NCRBUTTONUP
ISS_ShowContextMenu()
{
	If (A_Gui != 1)
		return
	Menu, ISSMenu, Show
	return 1
}

;bZ[WEBhEɃJ[\ANeBuȃEBhELĂ
ISS_WM_NCMOUSEMOVE()
{
	Global
	If (A_Gui == 1)
		WinGet, ISS_hActiveWnd, ID, A
	return
}

;===============================================================================
;                              bZ[W\֘A
;===============================================================================
;bZ[W\
;	:
;		m	\镶(ȗbZ[W)
;		t	\鎞ԁA0Ŗ\(~bAȗ0)
mes(m = "-", t = 0)
{
	GuiControl, 1:, ISS_MwCtlMes, %m%
	GuiControl, 1:Show, ISS_MwCtlMes
	if (t > 0)
		SetTimer, ISS_mesReset, -%t%
}

ISS_mesReset:
	GuiControl, 1:, ISS_MwCtlMes, -
	return

;xbZ[W\
;	:
;		w       \镶(ȗx)
;		t       \鎞ԁA0Ŗ\(~bAȗ0)
;		blink   trueœ_ŁAfalseœ_łȂ(ȗfalse)
;		wcol    F(ȗftHgF)
;		bgcol   wiF(ȗftHgF)
warn(w = "", t = 0, blink = false, wcol = "", bgcol = "")
{
	Global ISS_MwWarnBGColor
	If (w == "") {
		Gosub, ISS_warnReset
		return
	}
	ISS_MwWarnBGColor := bgcol
	GuiControl, 1:,ISS_MwCtlWarn,%w%
	GuiControl, 1:Show, ISS_MwCtlWarn
	GuiControl, 1:Hide, ISS_MwCtlMes
	If (wcol != "")
		GuiControl, 1:+c%wcol%, ISS_MwCtlWarn
	If (bgcol != "")
		Gui, 1:Color, %bgcol%
	if (t > 0)
		SetTimer, ISS_warnReset, -%t%
	if (blink)
		SetTimer, ISS_warnBlink, 550
}

ISS_warnReset:
	SetTimer, ISS_warnBlink, Off
	If (A_IsSuspended)
		return
	Gui, 1:Color, %ISS_MwBGColor%
	GuiControl, 1:+c%ISS_MwWarnColor%, ISS_MwCtlWarn
	GuiControl, 1:Hide, ISS_MwCtlWarn
	GuiControl, 1:Show, ISS_MwCtlMes
	return

ISS_warnBlink:
	If (!A_IsSuspended)
		ISS_warnBlink()
	return

ISS_warnBlink()
{
	Local v
	GuiControlGet, v,1:Visible, ISS_MwCtlWarn
	GuiControl, 1:Hide%v%, ISS_MwCtlWarn
	Gui, 1:Color, % v ? ISS_MwBGColor : ISS_MwWarnBGColor
	SetTimer, ISS_warnBlink, % 550 - v*100
	return
}

;c[`bvɃbZ[W\
;	:
;		msg   \郁bZ[W
;		t     \鎞(~bA0Ŗ\Aȗ0)
;		x, y  \ʒuAȗ̓}EXJ[\ʒu
ISS_ToolTip(msg, t = 0, x = "", y = "")
{
	ToolTip, %msg%, %x%, %y%
	If (t > 0)
		SetTimer, ISS_ToolTipHide, -%t%
	else
		SetTimer, ISS_ToolTipHide, Off
	return
}

ISS_ToolTipHide:
	ToolTip
	return

;===============================================================================
;                                  ̑֐
;===============================================================================
;zbgL[񒆂̃gK[L[Ԃ
ISS_GetTriggerKey(key)
{
	key := RegExReplace(key, "^.+?\\s&\\s(.+)$", "$1")	;[key1 & ]폜
	return RegExReplace(key, "^[\\^+!#~]+(.+)$", "$1")	;CL[폜
}

;񕪊
;	:
;		var       ϐ
;		dlmt      ؂蕶
;		is_dbcs   true2oCgƂď
;		p1 - p8   i[ϐ(p2ȍ~͏ȗ)
;	߂l:
;		ꂽԂ(ő8)
ISS_SplitVar(ByRef var, dlmt, is_dbcs, ByRef p1, ByRef p2="", ByRef p3=""
           , ByRef p4="", ByRef p5="", ByRef p6="", ByRef p7="", ByRef p8="")
{
	If (is_dbcs) {
		StringLen, len, var
		cnt := 0
		p0 := 1
		Loop, 8
			p%A_Index% := ""
		Loop {
			StringMid, c, var, % ++cnt, 1
			If (DllCall("IsDBCSLeadByte", UChar, Asc(c)))
				StringMid, c, var, % cnt++, 2
			If (c == dlmt)
				p0++
			else
				p%p0% .= c
			If (cnt >= len || p0 > 8)
				break
		}
	}
	else
		StringSplit, p, var, %dlmt%
	return p0 > 8 ? 8 : p0
}

;͒ۂԂ
ISS_IsEditActive()
{
	Global ISS_ISPID
	;1.tH[JX̂Rg[̃NXEdit܂܂ꍇ
	ControlGetFocus, ctl, ahk_group CSWindow
	IfInString, ctl, PageEditView	;PageEditView͏
		return false
	IfInString, ctl, Edit
		return true
	;2.eLXgc[œ͒
	;	ueLXgvpeBvƂEBhE
	;	eLXgc[œ͒Ƃ݂Ȃ
	IfWinExist, eLXgvpeB ahk_pid %ISS_ISPID%
		return true
	return false
}
;eLXgvpeB

;gpGUIԍԂ
ISS_GetNewGUI()
{
	Loop, 99 {
		If (A_Index == 1)	;1̓bZ[WEBhEŎgp
			continue
		Gui, %A_Index%:+LastFoundExist
		IfWinNotExist
			return A_Index
	}
	return 0
}